--- db/mysql-upgrade-long_output.sql	1970-01-01-12:00:00.000000000 +0100
+++ db/mysql-upgrade-long_output.sql	2008-11-28 11:18:03.138873455 +0100
@@ -0,0 +1,18 @@
+-- BEGIN long_output patch
+
+ALTER TABLE `nagios_hostchecks`
+	ADD COLUMN `long_output` varchar(8192) NOT NULL default '';
+
+ALTER TABLE `nagios_hoststatus`
+	ADD COLUMN `long_output` varchar(8192) NOT NULL default '';
+
+ALTER TABLE `nagios_servicechecks`
+	ADD COLUMN `long_output` varchar(8192) NOT NULL default '';
+
+ALTER TABLE `nagios_servicestatus`
+	ADD COLUMN `long_output` varchar(8192) NOT NULL default '';
+
+ALTER TABLE `nagios_statehistory`
+	ADD COLUMN `long_output` varchar(8192) NOT NULL default '';
+
+-- END long_output patch
Index: db/mysql.sql
===================================================================
RCS file: /cvsroot/nagios/ndoutils/db/mysql.sql,v
retrieving revision 1.4
diff -u -r1.4 mysql.sql
--- db/mysql.sql	29 Aug 2007 15:20:44 -0000	1.4
+++ db/mysql.sql	2 Dec 2008 15:49:04 -0000
@@ -538,6 +538,7 @@
   `latency` double NOT NULL default '0',
   `return_code` smallint(6) NOT NULL default '0',
   `output` varchar(255) NOT NULL default '',
+  `long_output` varchar(8192) NOT NULL default '',
   `perfdata` varchar(255) NOT NULL default '',
   PRIMARY KEY  (`hostcheck_id`),
   UNIQUE KEY `instance_id` (`instance_id`,`host_object_id`,`start_time`,`start_time_usec`)
@@ -729,6 +730,7 @@
   `host_object_id` int(11) NOT NULL default '0',
   `status_update_time` datetime NOT NULL default '0000-00-00 00:00:00',
   `output` varchar(255) NOT NULL default '',
+  `long_output` varchar(8192) NOT NULL default '',
   `perfdata` varchar(255) NOT NULL default '',
   `current_state` smallint(6) NOT NULL default '0',
   `has_been_checked` smallint(6) NOT NULL default '0',
@@ -1002,6 +1004,7 @@
   `latency` double NOT NULL default '0',
   `return_code` smallint(6) NOT NULL default '0',
   `output` varchar(255) NOT NULL default '',
+  `long_output` varchar(8192) NOT NULL default '',
   `perfdata` varchar(255) NOT NULL default '',
   PRIMARY KEY  (`servicecheck_id`),
   UNIQUE KEY `instance_id` (`instance_id`,`service_object_id`,`start_time`,`start_time_usec`)
@@ -1189,6 +1192,7 @@
   `service_object_id` int(11) NOT NULL default '0',
   `status_update_time` datetime NOT NULL default '0000-00-00 00:00:00',
   `output` varchar(255) NOT NULL default '',
+  `long_output` varchar(8192) NOT NULL default '',
   `perfdata` varchar(255) NOT NULL default '',
   `current_state` smallint(6) NOT NULL default '0',
   `has_been_checked` smallint(6) NOT NULL default '0',
@@ -1255,6 +1259,7 @@
   `last_state` smallint(6) NOT NULL default '-1',
   `last_hard_state` smallint(6) NOT NULL default '-1',
   `output` varchar(255) NOT NULL default '',
+  `long_output` varchar(8192) NOT NULL default '',
   PRIMARY KEY  (`statehistory_id`)
 ) ENGINE=InnoDB COMMENT='Historical host and service state changes';
 
Index: include/protoapi.h
===================================================================
RCS file: /cvsroot/nagios/ndoutils/include/protoapi.h,v
retrieving revision 1.3
diff -u -r1.3 protoapi.h
--- include/protoapi.h	27 Sep 2007 17:20:30 -0000	1.3
+++ include/protoapi.h	2 Dec 2008 15:49:04 -0000
@@ -239,6 +239,7 @@
 #define NDO_DATA_STICKY                              122
 #define NDO_DATA_TIMEOUT                             123
 #define NDO_DATA_TRIGGEREDBY                         124
+#define NDO_DATA_LONGOUTPUT                          125
 
 /*********** OBJECT CONFIG DATA ATTRIBUTES **********/
 
Index: src/dbhandlers.c
===================================================================
RCS file: /cvsroot/nagios/ndoutils/src/dbhandlers.c,v
retrieving revision 1.7
diff -u -r1.7 dbhandlers.c
--- src/dbhandlers.c	31 Oct 2007 18:17:05 -0000	1.7
+++ src/dbhandlers.c	2 Dec 2008 15:49:05 -0000
@@ -989,7 +989,7 @@
 	double execution_time=0.0;
 	int return_code=0;
 	char *ts[2];
-	char *es[2];
+	char *es[3];
 	char *buf=NULL;
 	char *buf1=NULL;
 	int result=NDO_OK;
@@ -1010,12 +1010,13 @@
 
 	es[0]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_COMMANDLINE]);
 	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_OUTPUT]);
+	es[2]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,start_time.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,end_time.tv_sec);
 
 	/* save entry to db */
-	if(asprintf(&buf,"instance_id='%lu', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', command_line='%s', timeout='%d', early_timeout='%d', execution_time='%lf', return_code='%d', output='%s'"
+	if(asprintf(&buf,"instance_id='%lu', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', command_line='%s', timeout='%d', early_timeout='%d', execution_time='%lf', return_code='%d', output='%s', long_output='%s'"
 		    ,idi->dbinfo.instance_id
 		    ,ts[0]
 		    ,start_time.tv_usec
@@ -1027,6 +1028,7 @@
 		    ,execution_time
 		    ,return_code
 		    ,es[1]
+		    ,es[2]
 		   )==-1)
 		buf=NULL;
 
@@ -1055,7 +1057,7 @@
 	int type,flags,attr;
 	struct timeval tstamp;
 	char *ts[2];
-	char *es[3];
+	char *es[4];
 	int x=0;
 	int eventhandler_type=0;
 	int state=0;
@@ -1092,6 +1094,7 @@
 	es[0]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_COMMANDARGS]);
 	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_COMMANDLINE]);
 	es[2]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_OUTPUT]);
+	es[3]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,start_time.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,end_time.tv_sec);
@@ -1106,7 +1109,7 @@
 	result=ndo2db_get_object_id_with_insert(idi,NDO2DB_OBJECTTYPE_COMMAND,idi->buffered_input[NDO_DATA_COMMANDNAME],NULL,&command_id);
 
 	/* save entry to db */
-	if(asprintf(&buf,"instance_id='%lu', eventhandler_type='%d', object_id='%lu', state='%d', state_type='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', command_object_id='%lu', command_args='%s', command_line='%s', timeout='%d', early_timeout='%d', execution_time='%lf', return_code='%d', output='%s'"
+	if(asprintf(&buf,"instance_id='%lu', eventhandler_type='%d', object_id='%lu', state='%d', state_type='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', command_object_id='%lu', command_args='%s', command_line='%s', timeout='%d', early_timeout='%d', execution_time='%lf', return_code='%d', output='%s', long_output='%s'"
 		    ,idi->dbinfo.instance_id
 		    ,eventhandler_type
 		    ,object_id
@@ -1124,6 +1127,7 @@
 		    ,execution_time
 		    ,return_code
 		    ,es[2]
+		    ,es[3]
 		   )==-1)
 		buf=NULL;
 
@@ -1161,7 +1165,7 @@
 	int contacts_notified=0;
 	int result=NDO_OK;
 	char *ts[2];
-	char *es[1];
+	char *es[2];
 	int x=0;
 	char *buf=NULL;
 	char *buf1=NULL;
@@ -1183,6 +1187,7 @@
 	result=ndo2db_convert_string_to_timeval(idi->buffered_input[NDO_DATA_ENDTIME],&end_time);
 
 	es[0]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_OUTPUT]);
+	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,start_time.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,end_time.tv_sec);
@@ -1194,7 +1199,7 @@
 		result=ndo2db_get_object_id_with_insert(idi,NDO2DB_OBJECTTYPE_HOST,idi->buffered_input[NDO_DATA_HOST],NULL,&object_id);
 
 	/* save entry to db */
-	if(asprintf(&buf,"instance_id='%lu', notification_type='%d', notification_reason='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', object_id='%lu', state='%d', output='%s', escalated='%d', contacts_notified='%d'"
+	if(asprintf(&buf,"instance_id='%lu', notification_type='%d', notification_reason='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', object_id='%lu', state='%d', output='%s', long_output='%s', escalated='%d', contacts_notified='%d'"
 		    ,idi->dbinfo.instance_id
 		    ,notification_type
 		    ,notification_reason
@@ -1205,6 +1210,7 @@
 		    ,object_id
 		    ,state
 		    ,es[0]
+		    ,es[1]
 		    ,escalated
 		    ,contacts_notified
 		   )==-1)
@@ -1393,7 +1399,7 @@
 	int type,flags,attr;
 	struct timeval tstamp;
 	char *ts[2];
-	char *es[4];
+	char *es[5];
 	int check_type=0;
 	struct timeval start_time;
 	struct timeval end_time;
@@ -1447,6 +1453,7 @@
 	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_COMMANDLINE]);
 	es[2]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_OUTPUT]);
 	es[3]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_PERFDATA]);
+	es[4]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,start_time.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,end_time.tv_sec);
@@ -1461,7 +1468,7 @@
 		command_id=0L;
 
 	/* save entry to db */
-	if(asprintf(&buf1,"instance_id='%lu', service_object_id='%lu', check_type='%d', current_check_attempt='%d', max_check_attempts='%d', state='%d', state_type='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', timeout='%d', early_timeout='%d', execution_time='%lf', latency='%lf', return_code='%d', output='%s', perfdata='%s'"
+	if(asprintf(&buf1,"instance_id='%lu', service_object_id='%lu', check_type='%d', current_check_attempt='%d', max_check_attempts='%d', state='%d', state_type='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', timeout='%d', early_timeout='%d', execution_time='%lf', latency='%lf', return_code='%d', output='%s', perfdata='%s', long_output='%s'"
 		    ,idi->dbinfo.instance_id
 		    ,object_id
 		    ,check_type
@@ -1480,6 +1487,7 @@
 		    ,return_code
 		    ,es[2]
 		    ,es[3]
+		    ,es[4]
 		   )==-1)
 		buf1=NULL;
 
@@ -1511,7 +1519,7 @@
 	int type,flags,attr;
 	struct timeval tstamp;
 	char *ts[2];
-	char *es[4];
+	char *es[5];
 	int check_type=0;
 	int is_raw_check=0;
 	struct timeval start_time;
@@ -1568,6 +1576,7 @@
 	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_COMMANDLINE]);
 	es[2]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_OUTPUT]);
 	es[3]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_PERFDATA]);
+	es[4]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,start_time.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,end_time.tv_sec);
@@ -1588,7 +1597,7 @@
 		is_raw_check=0;
 
 	/* save entry to db */
-	if(asprintf(&buf1,"instance_id='%lu', host_object_id='%lu', check_type='%d', is_raw_check='%d', current_check_attempt='%d', max_check_attempts='%d', state='%d', state_type='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', timeout='%d', early_timeout='%d', execution_time='%lf', latency='%lf', return_code='%d', output='%s', perfdata='%s'"
+	if(asprintf(&buf1,"instance_id='%lu', host_object_id='%lu', check_type='%d', is_raw_check='%d', current_check_attempt='%d', max_check_attempts='%d', state='%d', state_type='%d', start_time=%s, start_time_usec='%lu', end_time=%s, end_time_usec='%lu', timeout='%d', early_timeout='%d', execution_time='%lf', latency='%lf', return_code='%d', output='%s', perfdata='%s', long_output='%s'"
 		    ,idi->dbinfo.instance_id
 		    ,object_id
 		    ,check_type
@@ -1608,6 +1617,7 @@
 		    ,return_code
 		    ,es[2]
 		    ,es[3]
+		    ,es[4]
 		   )==-1)
 		buf1=NULL;
 
@@ -2232,7 +2242,7 @@
 	double normal_check_interval=0.0;
 	double retry_check_interval=0.0;
 	char *ts[10];
-	char *es[4];
+	char *es[5];
 	char *buf=NULL;
 	char *buf1=NULL;
 	unsigned long object_id=0L;
@@ -2298,6 +2308,7 @@
 	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_PERFDATA]);
 	es[2]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_EVENTHANDLER]);
 	es[3]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_CHECKCOMMAND]);
+	es[4]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,tstamp.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,last_check);
@@ -2315,12 +2326,13 @@
 	result=ndo2db_get_object_id_with_insert(idi,NDO2DB_OBJECTTYPE_TIMEPERIOD,idi->buffered_input[NDO_DATA_HOSTCHECKPERIOD],NULL,&check_timeperiod_object_id);
 
 	/* generate query string */
-	if(asprintf(&buf1,"instance_id='%lu', host_object_id='%lu', status_update_time=%s, output='%s', perfdata='%s', current_state='%d', has_been_checked='%d', should_be_scheduled='%d', current_check_attempt='%d', max_check_attempts='%d', last_check=%s, next_check=%s, check_type='%d', last_state_change=%s, last_hard_state_change=%s, last_hard_state='%d', last_time_up=%s, last_time_down=%s, last_time_unreachable=%s, state_type='%d', last_notification=%s, next_notification=%s, no_more_notifications='%d', notifications_enabled='%d', problem_has_been_acknowledged='%d', acknowledgement_type='%d', current_notification_number='%d', passive_checks_enabled='%d', active_checks_enabled='%d', event_handler_enabled='%d', flap_detection_enabled='%d', is_flapping='%d', percent_state_change='%lf', latency='%lf', execution_time='%lf', scheduled_downtime_depth='%d', failure_prediction_enabled='%d', process_performance_data='%d', obsess_over_host='%d', modified_host_attributes='%lu', event_handler='%s', check_command='%s', normal_check_interval='%lf', retry_check_interval='%lf', check_timeperiod_object_id='%lu'"
+	if(asprintf(&buf1,"instance_id='%lu', host_object_id='%lu', status_update_time=%s, output='%s', perfdata='%s', long_output='%s', current_state='%d', has_been_checked='%d', should_be_scheduled='%d', current_check_attempt='%d', max_check_attempts='%d', last_check=%s, next_check=%s, check_type='%d', last_state_change=%s, last_hard_state_change=%s, last_hard_state='%d', last_time_up=%s, last_time_down=%s, last_time_unreachable=%s, state_type='%d', last_notification=%s, next_notification=%s, no_more_notifications='%d', notifications_enabled='%d', problem_has_been_acknowledged='%d', acknowledgement_type='%d', current_notification_number='%d', passive_checks_enabled='%d', active_checks_enabled='%d', event_handler_enabled='%d', flap_detection_enabled='%d', is_flapping='%d', percent_state_change='%lf', latency='%lf', execution_time='%lf', scheduled_downtime_depth='%d', failure_prediction_enabled='%d', process_performance_data='%d', obsess_over_host='%d', modified_host_attributes='%lu', event_handler='%s', check_command='%s', normal_check_interval='%lf', retry_check_interval='%lf', check_timeperiod_object_id='%lu'"
 		    ,idi->dbinfo.instance_id
 		    ,object_id
 		    ,ts[0]
 		    ,es[0]
 		    ,es[1]
+		    ,es[4]
 		    ,current_state
 		    ,has_been_checked
 		    ,should_be_scheduled
@@ -2471,7 +2483,7 @@
 	double normal_check_interval=0.0;
 	double retry_check_interval=0.0;
 	char *ts[11];
-	char *es[4];
+	char *es[5];
 	char *buf=NULL;
 	char *buf1=NULL;
 	unsigned long object_id=0L;
@@ -2538,6 +2550,7 @@
 	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_PERFDATA]);
 	es[2]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_EVENTHANDLER]);
 	es[3]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_CHECKCOMMAND]);
+	es[4]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,tstamp.tv_sec);
 	ts[1]=ndo2db_db_timet_to_sql(idi,last_check);
@@ -2556,12 +2569,13 @@
 	result=ndo2db_get_object_id_with_insert(idi,NDO2DB_OBJECTTYPE_TIMEPERIOD,idi->buffered_input[NDO_DATA_SERVICECHECKPERIOD],NULL,&check_timeperiod_object_id);
 
 	/* generate query string */
-	if(asprintf(&buf1,"instance_id='%lu', service_object_id='%lu', status_update_time=%s, output='%s', perfdata='%s', current_state='%d', has_been_checked='%d', should_be_scheduled='%d', current_check_attempt='%d', max_check_attempts='%d', last_check=%s, next_check=%s, check_type='%d', last_state_change=%s, last_hard_state_change=%s, last_hard_state='%d', last_time_ok=%s, last_time_warning=%s, last_time_unknown=%s, last_time_critical=%s, state_type='%d', last_notification=%s, next_notification=%s, no_more_notifications='%d', notifications_enabled='%d', problem_has_been_acknowledged='%d', acknowledgement_type='%d', current_notification_number='%d', passive_checks_enabled='%d', active_checks_enabled='%d', event_handler_enabled='%d', flap_detection_enabled='%d', is_flapping='%d', percent_state_change='%lf', latency='%lf', execution_time='%lf', scheduled_downtime_depth='%d', failure_prediction_enabled='%d', process_performance_data='%d', obsess_over_service='%d', modified_service_attributes='%lu', event_handler='%s', check_command='%s', normal_check_interval='%lf', retry_check_interval='%lf', check_timeperiod_object_id='%lu'"
+	if(asprintf(&buf1,"instance_id='%lu', service_object_id='%lu', status_update_time=%s, output='%s', perfdata='%s', long_output='%s', current_state='%d', has_been_checked='%d', should_be_scheduled='%d', current_check_attempt='%d', max_check_attempts='%d', last_check=%s, next_check=%s, check_type='%d', last_state_change=%s, last_hard_state_change=%s, last_hard_state='%d', last_time_ok=%s, last_time_warning=%s, last_time_unknown=%s, last_time_critical=%s, state_type='%d', last_notification=%s, next_notification=%s, no_more_notifications='%d', notifications_enabled='%d', problem_has_been_acknowledged='%d', acknowledgement_type='%d', current_notification_number='%d', passive_checks_enabled='%d', active_checks_enabled='%d', event_handler_enabled='%d', flap_detection_enabled='%d', is_flapping='%d', percent_state_change='%lf', latency='%lf', execution_time='%lf', scheduled_downtime_depth='%d', failure_prediction_enabled='%d', process_performance_data='%d', obsess_over_service='%d', modified_service_attributes='%lu', event_handler='%s', check_command='%s', normal_check_interval='%lf', retry_check_interval='%lf', check_timeperiod_object_id='%lu'"
 		    ,idi->dbinfo.instance_id
 		    ,object_id
 		    ,ts[0]
 		    ,es[0]
 		    ,es[1]
+		    ,es[4]
 		    ,current_state
 		    ,has_been_checked
 		    ,should_be_scheduled
@@ -3003,7 +3017,7 @@
 	unsigned long object_id=0L;
 	int result=NDO_OK;
 	char *ts[1];
-	char *es[1];
+	char *es[2];
 	char *buf=NULL;
 
 	if(idi==NULL)
@@ -3027,6 +3041,7 @@
 	result=ndo2db_convert_string_to_int(idi->buffered_input[NDO_DATA_LASTSTATE],&last_state);
 
 	es[0]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_OUTPUT]);
+	es[1]=ndo2db_db_escape_string(idi,idi->buffered_input[NDO_DATA_LONGOUTPUT]);
 
 	ts[0]=ndo2db_db_timet_to_sql(idi,tstamp.tv_sec);
 
@@ -3037,7 +3052,7 @@
 		result=ndo2db_get_object_id_with_insert(idi,NDO2DB_OBJECTTYPE_HOST,idi->buffered_input[NDO_DATA_HOST],NULL,&object_id);
 
 	/* save entry to db */
-	if(asprintf(&buf,"INSERT INTO %s SET instance_id='%lu', state_time=%s, state_time_usec='%lu', object_id='%lu', state_change='%d', state='%d', state_type='%d', current_check_attempt='%d', max_check_attempts='%d', last_state='%d', last_hard_state='%d', output='%s'"
+	if(asprintf(&buf,"INSERT INTO %s SET instance_id='%lu', state_time=%s, state_time_usec='%lu', object_id='%lu', state_change='%d', state='%d', state_type='%d', current_check_attempt='%d', max_check_attempts='%d', last_state='%d', last_hard_state='%d', output='%s', long_output='%s'"
 		    ,ndo2db_db_tablenames[NDO2DB_DBTABLE_STATEHISTORY]
 		    ,idi->dbinfo.instance_id
 		    ,ts[0]
@@ -3051,6 +3066,7 @@
 		    ,last_state
 		    ,last_hard_state
 		    ,es[0]
+		    ,es[1]
 		   )==-1)
 		buf=NULL;
 
Index: src/ndo2db.c
===================================================================
RCS file: /cvsroot/nagios/ndoutils/src/ndo2db.c,v
retrieving revision 1.9
diff -u -r1.9 ndo2db.c
--- src/ndo2db.c	25 Jan 2008 16:09:17 -0000	1.9
+++ src/ndo2db.c	2 Dec 2008 15:49:05 -0000
@@ -1338,6 +1338,7 @@
 	case NDO_DATA_HOST:
 	case NDO_DATA_LOGENTRY:
 	case NDO_DATA_OUTPUT:
+	case NDO_DATA_LONGOUTPUT:
 	case NDO_DATA_PERFDATA:
 	case NDO_DATA_SERVICE:
 	case NDO_DATA_PROGRAMNAME:
Index: src/ndomod.c
===================================================================
RCS file: /cvsroot/nagios/ndoutils/src/ndomod.c,v
retrieving revision 1.10
diff -u -r1.10 ndomod.c
--- src/ndomod.c	25 Jan 2008 16:09:17 -0000	1.10
+++ src/ndomod.c	2 Dec 2008 15:49:05 -0000
@@ -1129,7 +1129,7 @@
 #ifdef BUILD_NAGIOS_3X
 	contact *temp_contact=NULL;
 #endif
-	char *es[8];
+	char *es[9];
 	int x=0;
 	scheduled_downtime *temp_downtime=NULL;
 	comment *temp_comment=NULL;
@@ -1666,9 +1666,12 @@
 		es[4]=ndo_escape_buffer(scdata->command_line);
 		es[5]=ndo_escape_buffer(scdata->output);
 		es[6]=ndo_escape_buffer(scdata->perf_data);
+#ifdef BUILD_NAGIOS_3X
+		es[7]=ndo_escape_buffer(scdata->long_output);
+#endif
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%s\n%d=%s\n%d\n\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d\n\n"
 			 ,NDO_API_SERVICECHECKDATA
 			 ,NDO_DATA_TYPE
 			 ,scdata->type
@@ -1719,6 +1722,8 @@
 			 ,(es[5]==NULL)?"":es[5]
 			 ,NDO_DATA_PERFDATA
 			 ,(es[6]==NULL)?"":es[6]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[7]==NULL)?"":es[7]
 			 ,NDO_API_ENDDATA
 			);
 
@@ -1737,9 +1742,12 @@
 		es[3]=ndo_escape_buffer(hcdata->command_line);
 		es[4]=ndo_escape_buffer(hcdata->output);
 		es[5]=ndo_escape_buffer(hcdata->perf_data);
+#ifdef BUILD_NAGIOS_3X
+		es[6]=ndo_escape_buffer(hcdata->long_output);
+#endif
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%s\n%d=%s\n%d\n\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d\n\n"
 			 ,NDO_API_HOSTCHECKDATA
 			 ,NDO_DATA_TYPE
 			 ,hcdata->type
@@ -1788,6 +1796,8 @@
 			 ,(es[4]==NULL)?"":es[4]
 			 ,NDO_DATA_PERFDATA
 			 ,(es[5]==NULL)?"":es[5]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[6]==NULL)?"":es[6]
 			 ,NDO_API_ENDDATA
 			);
 
@@ -2033,15 +2043,16 @@
 		es[4]=ndo_escape_buffer(temp_host->host_check_command);
 		es[5]=ndo_escape_buffer(temp_host->check_period);
 
-#ifdef BUILLD_NAGIOS_3X
+#ifdef BUILD_NAGIOS_3X
 		retry_interval=temp_host->retry_interval;
+		es[6]=ndo_escape_buffer(temp_host->long_plugin_output);
 #endif
 #ifdef BUILD_NAGIOS_2X
 		retry_interval=0.0;
 #endif
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%s\n%d=%s\n%d=%lf\n%d=%lf\n%d=%s\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%s\n%d=%s\n%d=%lf\n%d=%lf\n%d=%s\n"
 			 ,NDO_API_HOSTSTATUSDATA
 			 ,NDO_DATA_TYPE
 			 ,hsdata->type
@@ -2058,6 +2069,8 @@
 			 ,(es[1]==NULL)?"":es[1]
 			 ,NDO_DATA_PERFDATA
 			 ,(es[2]==NULL)?"":es[2]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[6]==NULL)?"":es[6]
 			 ,NDO_DATA_CURRENTSTATE
 			 ,temp_host->current_state
 			 ,NDO_DATA_HASBEENCHECKED
@@ -2195,9 +2208,12 @@
 		es[4]=ndo_escape_buffer(temp_service->event_handler);
 		es[5]=ndo_escape_buffer(temp_service->service_check_command);
 		es[6]=ndo_escape_buffer(temp_service->check_period);
+#ifdef BUILD_NAGIOS_3X
+		es[7]=ndo_escape_buffer(temp_service->long_plugin_output);
+#endif
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%s\n%d=%s\n%d=%lf\n%d=%lf\n%d=%s\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%lu\n%d=%lu\n%d=%d\n%d=%lu\n%d=%lu\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%.5lf\n%d=%.5lf\n%d=%.5lf\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%lu\n%d=%s\n%d=%s\n%d=%lf\n%d=%lf\n%d=%s\n"
 			 ,NDO_API_SERVICESTATUSDATA
 			 ,NDO_DATA_TYPE
 			 ,ssdata->type
@@ -2216,6 +2232,8 @@
 			 ,(es[2]==NULL)?"":es[2]
 			 ,NDO_DATA_PERFDATA
 			 ,(es[3]==NULL)?"":es[3]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[7]==NULL)?"":es[7]
 			 ,NDO_DATA_CURRENTSTATE
 			 ,temp_service->current_state
 			 ,NDO_DATA_HASBEENCHECKED
@@ -2719,7 +2737,7 @@
 		es[5]=ndo_escape_buffer(cnotdata->contact_name);
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%d\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d\n\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%d\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d\n\n"
 			 ,NDO_API_CONTACTNOTIFICATIONDATA
 			 ,NDO_DATA_TYPE
 			 ,cnotdata->type
@@ -2754,6 +2772,8 @@
 			 ,(es[3]==NULL)?"":es[3]
 			 ,NDO_DATA_ACKDATA
 			 ,(es[4]==NULL)?"":es[4]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[6]==NULL)?"":es[6]
 			 ,NDO_API_ENDDATA
 			);
 
@@ -2776,7 +2796,7 @@
 		es[7]=ndo_escape_buffer(cnotmdata->command_args);
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%d\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d\n\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%d\n%d=%ld.%ld\n%d=%ld.%ld\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d=%s\n%d=%s\n%d\n\n"
 			 ,NDO_API_CONTACTNOTIFICATIONMETHODDATA
 			 ,NDO_DATA_TYPE
 			 ,cnotmdata->type
@@ -2815,6 +2835,8 @@
 			 ,(es[3]==NULL)?"":es[3]
 			 ,NDO_DATA_ACKDATA
 			 ,(es[4]==NULL)?"":es[4]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[8]==NULL)?"":es[8]
 			 ,NDO_API_ENDDATA
 			);
 
@@ -2899,6 +2921,7 @@
 				}
 			last_state=temp_host->last_state;
 			last_state=temp_host->last_hard_state;
+			es[3]=ndo_escape_buffer(temp_host->long_plugin_output);
 			}
 		else{
 			if((temp_service=(service *)schangedata->object_ptr)==NULL){
@@ -2907,6 +2930,7 @@
 				}
 			last_state=temp_service->last_state;
 			last_hard_state=temp_service->last_hard_state;
+			es[3]=ndo_escape_buffer(temp_service->long_plugin_output);
 			}
 #endif
 
@@ -2915,7 +2939,7 @@
 		es[2]=ndo_escape_buffer(schangedata->output);
 
 		snprintf(temp_buffer,sizeof(temp_buffer)-1
-			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%d\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%s\n%d\n\n"
+			 ,"\n%d:\n%d=%d\n%d=%d\n%d=%d\n%d=%ld.%ld\n%d=%d\n%d=%s\n%d=%s\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%d\n%d=%s\n%d=%s\n%d\n\n"
 			 ,NDO_API_STATECHANGEDATA
 			 ,NDO_DATA_TYPE
 			 ,schangedata->type
@@ -2947,7 +2971,9 @@
 			 ,NDO_DATA_LASTHARDSTATE
 			 ,last_hard_state
 			 ,NDO_DATA_OUTPUT
-			 ,es[2]
+			 ,(es[2]==NULL)?"":es[2]
+			 ,NDO_DATA_LONGOUTPUT
+			 ,(es[3]==NULL)?"":es[3]
 			 ,NDO_API_ENDDATA
 			);
 
